## Introduction

### Why? What?

The IML appmonitor has a client and a server written in PHP.
👉 See 🌐 <https://github.com/iml-it/appmonitor>

All our web projects running with PHP were simple to integrate. But what about all the projects running on NodeJs, Ruby, Python, Java? The can run their checks and need to create a JSON response in the required syntax.

This project was initiated to create a compiled client from PHP sources that can be configured with an ini file to perform needed checks. Such a binary is independent from any programming language.

### The result

A single binary without dependencies can be put on a Linux target host.
It can perform all checks that the current Appmonitor client as Php client can execute.

With command line parameter `--ini=<INIFILE>` it processes the checks that are defined there.

![alt text](images/screenshot_test_php_modules.png)

## Requirements

### For usage of the client

* A binary for your platform must be available for download or must be built. Linux x86_64 is the 1st target platform
* no other requirements/ dependencies

### To built a new binary

* git
* wget
* PHP 8 cli client (no special modules needed)

Tested on Linux only so far.
