## Introduction

To embed the cli tool into your web application you need to

* perform the execution of the binary with referencing the ini `<PATH>amcli --ini=<INI-FILE>`
* catch exitcode and output of STDOUT
* check returncode: 
  * if it is `0` then the excution was successful - we have a result. You can send the JSON after setting the content type as http response header
  * if it is `> 0` the response is no JSON syntax. You should send the output that the error is seen in the appm nitor server.

Don't forget to protect the ini file and the monitoring request. See page Security.

## PHP

This code snippet is for demonstration purposes only. A PHP web app should use the PHP client - see <https://os-docs.iml.unibe.ch/appmonitor/PHP_client/index.html>

```php
<?php

$sCommand = "/usr/local/bin/amcli --ini=/var/www/www.example.com/checks.ini";
$aOut = [];

exec($sCommand, $aOut, $iRc);

if ($iRc == 0) {
    header('Content-type: application/json');
} else {
    header("HTTP/1.1 503 Service unavailable");
    echo "<h1>503 Service unavailable</h1>\n";
}
echo implode("\n", $aOut);
```

To test it:

(1)

Start PHP webserver

```txt
$ cd examples
$ php -S localhost:9000
[Fri Mar  7 09:01:52 2025] PHP 8.4.4 Development Server (http://localhost:9000) started
```


(2)

In a webbrowser open <http://localhost:9000/embed_example.php>

## Cronjob

You can setup a cronjob starting every minute. Its output you can write into a json file that is accessible by the webservice.
You can 

(1)

```txt
* * * * * root /usr/local/bin/amcli --ini=/var/www/www.example.com/checks.ini > /var/www/www.example.com/public/appmonitor/appmonitor.json 2>/dev/null
```

(2)

In the appmonitor server add the url to the generated static file for monitoring eg `https://www.example.com/appmonitor/appmonitor.json`.
